﻿/*
 * Name: Hamming code generator code for redundency checking
 * Author: Sorin Liviu Jurj
 * 
 * Description:
*
*
*
*
*
*
 */

using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using System.IO.Ports;
using System.Collections;
using System.IO;

namespace WpfApp2_uart_combobox
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {

        public MainWindow()
        {
            InitializeComponent();
        }

        bool firstFlag = false;
        string inputstring_t;
        int num_t = 0x00;
        int len_t;
        int i, offset = 0;
        int lastbit_t;
        BitArray Polybits_t = new BitArray(5);

        /*
        Button event for STEP RUN 
        */
        private void Button_Click_1(object sender, RoutedEventArgs e)
        {
            string outputstring = "";
            string Polystring_t = "";
            BitArray bits_t = new BitArray(4);
            BitArray outbits_t = new BitArray(4);
            int num0, num1, num2, num3;
            string polyfun = "x^4";

            /*STEP RUN arrival of first step*/
            if (firstFlag == false)
            {
                firstFlag = true;
                recieve_box.IsReadOnly = true;
                box_binary.IsReadOnly = true;

                if (!String.IsNullOrEmpty(box_binary.Text))
                {
                    Polystring_t = box_binary.Text;
                    Polybits_t[0] = Polystring_t[4] == '1' ? true : false;
                    Polybits_t[1] = Polystring_t[3] == '1' ? true : false;
                    Polybits_t[2] = Polystring_t[2] == '1' ? true : false;
                    Polybits_t[3] = Polystring_t[1] == '1' ? true : false;
                    Polybits_t[4] = Polystring_t[0] == '1' ? true : false;

                    polyfun = Polybits_t[3] ? polyfun + "+x^3" : polyfun + "";
                    polyfun = Polybits_t[2] ? polyfun + "+x^2" : polyfun + "";
                    polyfun = Polybits_t[1] ? polyfun + "+x^1" : polyfun + "";
                    polyfun += "+1";
                    box_polynomial.Text = polyfun;

                    /*
                    checkimg if valid data is available in BOX A
                    */
                    if (!String.IsNullOrEmpty(recieve_box.Text))
                    {
                        inputstring_t = recieve_box.Text;
                        len_t = inputstring_t.Length;
                        lastbit_t = inputstring_t[len_t - 1] == '1' ? 1 : 0;
                        totalCycles.Text = len_t.ToString();

                        /*Checks if data is binary and valid*/
                        if ((inputstring_t.Split('1').Length - 1) + (inputstring_t.Split('0').Length - 1) == len_t)
                        {
                            /*creates new signature*/
                            //num_t = ((num_t << 1) & 0x08) | ((num_t << 1) & 0x04) | (((num_t >> 2) ^ (num_t << 1)) & 0x02) | (((num_t >> 3) ^ lastbit_t) & 0x01);

                            bits_t[3] = ((num_t & 0x08) != 0 ? true : false);
                            bits_t[2] = ((num_t & 0x04) != 0 ? true : false);
                            bits_t[1] = ((num_t & 0x02) != 0 ? true : false);
                            bits_t[0] = ((num_t & 0x01) != 0 ? true : false);

                            //num = ((num << 1) & 0x08) | ((num << 1) & 0x04) | (((num >> 2) ^ (num << 1)) & 0x02) | (((num >> 3) ^ lastbit) & 0x01);

                            outbits_t[3] = Polybits_t[3] ? bits_t[3] ^ bits_t[2] : (bits_t[2] ? false : true);
                            outbits_t[2] = Polybits_t[2] ? bits_t[3] ^ bits_t[1] : (bits_t[1] ? false : true);
                            outbits_t[1] = Polybits_t[1] ? bits_t[3] ^ bits_t[0] : (bits_t[0] ? false : true);
                            outbits_t[0] = bits_t[3] ^ (lastbit_t != 0) ? true : false;

                            num3 = outbits_t[3] ? 0x08 : 0x00;
                            num2 = outbits_t[2] ? 0x04 : 0x00;
                            num1 = outbits_t[1] ? 0x02 : 0x00;
                            num0 = outbits_t[0] ? 0x01 : 0x00;

                            num_t = num3 | num2 | num1 | num0;

                            for (i = 0; i < 4; i++)
                            {
                                if (((num_t >> (3 - i)) & 0x01) == 1)
                                    outputstring += '1';
                                else
                                    outputstring += '0';
                            }

                            /*prints it in BOX*/
                            box_cycles.Text = (offset + 1).ToString();
                            recieve_box_Copy.Text = outputstring;
                            outputstring = "";

                            if (offset != len_t - 1)
                                lastbit_t = inputstring_t[len_t - (offset + 2)] == '1' ? 1 : 0;

                            offset++;
                            if (offset == len_t)
                            {
                                polyfun = "x^4";
                                num_t = 0x00;
                                offset = 0;
                                firstFlag = false;
                                recieve_box.IsReadOnly = false;
                                box_binary.IsReadOnly = false;
                            }

                        }
                        else
                        {
                            firstFlag = false;
                            recieve_box.IsReadOnly = false;
                            box_binary.IsReadOnly = false;
                            MessageBoxResult result = MessageBox.Show("INPUT CONTAINS INVALID BITS");
                        }
                    }
                    else
                    {
                        firstFlag = false;
                        recieve_box.IsReadOnly = false;
                        box_binary.IsReadOnly = false;
                        MessageBoxResult result = MessageBox.Show("INPUT NOT FOUND");
                    }
                }
                else
                {
                    firstFlag = false;
                    recieve_box.IsReadOnly = false;
                    box_binary.IsReadOnly = false;
                    MessageBoxResult result = MessageBox.Show("Polynomial NOT FOUND");
                }
            }
            /*STEP RUN arrival of consecutive steps*/
            else
            {
                //num_t = ((num_t << 1) & 0x08) | ((num_t << 1) & 0x04) | (((num_t >> 2) ^ (num_t << 1)) & 0x02) | (((num_t >> 3) ^ lastbit_t) & 0x01);

                bits_t[3] = ((num_t & 0x08) != 0 ? true : false);
                bits_t[2] = ((num_t & 0x04) != 0 ? true : false);
                bits_t[1] = ((num_t & 0x02) != 0 ? true : false);
                bits_t[0] = ((num_t & 0x01) != 0 ? true : false);

                //num = ((num << 1) & 0x08) | ((num << 1) & 0x04) | (((num >> 2) ^ (num << 1)) & 0x02) | (((num >> 3) ^ lastbit) & 0x01);

                outbits_t[3] = Polybits_t[3] ? bits_t[3] ^ bits_t[2] : (bits_t[2] ? false : true);
                outbits_t[2] = Polybits_t[2] ? bits_t[3] ^ bits_t[1] : (bits_t[1] ? false : true);
                outbits_t[1] = Polybits_t[1] ? bits_t[3] ^ bits_t[0] : (bits_t[0] ? false : true);
                outbits_t[0] = bits_t[3] ^ (lastbit_t != 0) ? true : false;

                num3 = outbits_t[3] ? 0x08 : 0x00;
                num2 = outbits_t[2] ? 0x04 : 0x00;
                num1 = outbits_t[1] ? 0x02 : 0x00;
                num0 = outbits_t[0] ? 0x01 : 0x00;

                num_t = num3 | num2 | num1 | num0;

                for (i = 0; i < 4; i++)
                {
                    if (((num_t >> (3 - i)) & 0x01) == 1)
                        outputstring += '1';
                    else
                        outputstring += '0';
                }

                box_cycles.Text = (offset + 1).ToString();
                recieve_box_Copy.Text = outputstring;
                outputstring = "";

                if (offset != len_t - 1)
                    lastbit_t = inputstring_t[len_t - (offset + 2)] == '1' ? 1 : 0;

                offset++;
                if(offset == len_t)
                {
                    polyfun = "x^4";
                    num_t = 0x00;
                    offset = 0;
                    firstFlag = false;
                    recieve_box.IsReadOnly = false;
                    box_binary.IsReadOnly = false;
                }
            }

        }

        /*
        Button event for RUN 
        */
        private void Button_Click_2(object sender, RoutedEventArgs e)
        {
            string inputstring;
            string Polystring;
            string outputstring = "";
            int num = 0x00;
            int len;
            int i,j;
            int lastbit ;
            BitArray bits = new BitArray(4);
            BitArray Polybits = new BitArray(5);
            BitArray outbits = new BitArray(4);
            int num0, num1, num2, num3;
            string polyfun = "x^4";

            recieve_box.IsReadOnly = true;
            box_binary.IsReadOnly = true;

            if (!String.IsNullOrEmpty(box_binary.Text))
            {
                Polystring = box_binary.Text;
                Polybits[0] = Polystring[4] == '1' ? true : false;
                Polybits[1] = Polystring[3] == '1' ? true : false;
                Polybits[2] = Polystring[2] == '1' ? true : false;
                Polybits[3] = Polystring[1] == '1' ? true : false;
                Polybits[4] = Polystring[0] == '1' ? true : false;

                polyfun = Polybits[3] ? polyfun + "+x^3" : polyfun + "";
                polyfun = Polybits[2] ? polyfun + "+x^2" : polyfun + "";
                polyfun = Polybits[1] ? polyfun + "+x^1" : polyfun + "";
                polyfun += "+1";
                box_polynomial.Text = polyfun;

                /*
                 checkimg if valid data is available in BOX A
                 */
                if (!String.IsNullOrEmpty(recieve_box.Text))
                {

                    inputstring = recieve_box.Text;
                    len = inputstring.Length;
                    lastbit = inputstring[len - 1] == '1' ? 1 : 0;
                    totalCycles.Text = len.ToString();

                    /*Checks if data is binary and valid*/
                    if ((inputstring.Split('1').Length - 1) + (inputstring.Split('0').Length - 1) == len)
                    {

                        for (j = 0; j < len; j++)
                        {
                            /*creates new signature*/

                            bits[3] = ((num & 0x08) != 0 ? true : false);
                            bits[2] = ((num & 0x04) != 0 ? true : false);
                            bits[1] = ((num & 0x02) != 0 ? true : false);
                            bits[0] = ((num & 0x01) != 0 ? true : false);

                            //num = ((num << 1) & 0x08) | ((num << 1) & 0x04) | (((num >> 2) ^ (num << 1)) & 0x02) | (((num >> 3) ^ lastbit) & 0x01);

                            outbits[3] = Polybits[3] ? bits[3] ^ bits[2] : (bits[2] ? false : true);
                            outbits[2] = Polybits[2] ? bits[3] ^ bits[1] : (bits[1] ? false : true);
                            outbits[1] = Polybits[1] ? bits[3] ^ bits[0] : (bits[0] ? false : true);
                            outbits[0] = bits[3] ^ (lastbit != 0) ? true : false;

                            num3 = outbits[3] ? 0x08 : 0x00;
                            num2 = outbits[2] ? 0x04 : 0x00;
                            num1 = outbits[1] ? 0x02 : 0x00;
                            num0 = outbits[0] ? 0x01 : 0x00;

                            num = num3 | num2 | num1 | num0;

                            for (i = 0; i < 4; i++)
                            {
                                if (((num >> (3 - i)) & 0x01) == 1)
                                    outputstring += '1';
                                else
                                    outputstring += '0';
                            }
                            /*prints it in BOX*/
                            box_cycles.Text = (j + 1).ToString();
                            recieve_box_Copy.Text = outputstring;
                            outputstring = "";

                            if (j != len - 1)
                                lastbit = inputstring[len - (j + 2)] == '1' ? 1 : 0;
                        }
                    }
                    else
                    {
                        MessageBoxResult result = MessageBox.Show("INPUT CONTAINS INVALID BITS");
                    }
                }
                else
                {
                    MessageBoxResult result = MessageBox.Show("INPUT NOT FOUND");
                }
            }
            else
            {
                MessageBoxResult result = MessageBox.Show("Polynomial NOT FOUND");
            }

            num_t = 0x00;
            offset = 0;
            firstFlag = false;
            recieve_box.IsReadOnly = false;
            polyfun = "x^4";
            box_binary.IsReadOnly = false;

        }
    }  
}
